// Server Class

#include "server.h"
#include "user.h"

CServer* CServer::theserver = NULL;

CServer::CServer()
{
	rootuser=NULL;
}

CServer::~CServer()
{
    RemoveAllUsers();
    theserver=NULL;
}

void CServer::SocketMessageHandler(WPARAM wParam, LPARAM lParam)
{
    CUser* user;

	switch(WSAGETSELECTEVENT(lParam))
	{
        // Server socket has an incoming connection
        // Need to create a user and pass on the connection to its own socket
        case FD_ACCEPT:
            user = AddUser();
            user->socket.CreateSocket(&socket);

            break;
            
        // A socket has closed
        case FD_CLOSE:
            user = GetUser((SOCKET)wParam);
            delete user;
            break;

        // A socket has data that can be read
        case FD_READ:
            user = GetUser((SOCKET)wParam);
            // Add reading stuff in here
            break;
    }
}

CUser* CServer::AddUser()
{
    CUser* user = new CUser;

    user->next = rootuser;
    if(rootuser){rootuser->prev = user;}
    rootuser = user;

    return user;
}

CUser* CServer::AddUser(CUser* user)
{
    user->next = rootuser;
    if(rootuser){rootuser->prev = user;}
    rootuser = user;

    return user;
}

CUser* CServer::GetUser(SOCKET sock)
{
	for(CUser* curuser=rootuser; curuser != NULL; curuser=curuser->next)
    {
		if(curuser->socket.GetSocket()==sock)
        {
			return curuser;
        }
    }
	return 0;
}

void CServer::RemoveAllUsers()
{
    // When the root user is deleted, it will take care of itself and set rootuser to the next user in the list
    while(rootuser != NULL) {delete rootuser;}
}
