// Pure Virtual Base Class for Sockets 

#ifndef SOCK_H_INCLUDED
#define SOCK_H_INCLUDED

#include <windows.h>
#ifdef __BCPLUSPLUS__
#include <winsock2.h>
#endif

class CSocket
{
public:

    CSocket();
    virtual ~CSocket();

    inline int GetStatus() {return status;}
    inline SOCKET GetSocket() {return sock;}

    // Send text to the socket
    inline void SendText(char* message)
        { send(sock, message, strlen(message), 0); }

    // Pure Virtual to be defined by child classes.
    virtual void GetText(char* dest, int length) = 0;

    // Disconnect the socket
    void CloseSocket();

protected:
    // The winsock representation of a socket
    SOCKET sock;
    // The address of the socket (on TCP/IP this is hostname/ip and port)
    SOCKADDR_IN addr;

    // Connected?
    int status;

    // binds the address to the socket
    int BindSocket();

};

#endif // SOCK_H_INCLUDED
